package de.cliffbreak.varo.events;

import org.bukkit.event.Event;
import org.bukkit.event.HandlerList;

public class PlayerInteractNPCEvent extends Event {
    private static final HandlerList handlers = new HandlerList();
    private final Type type;
    private final int id;
    private final double damage;
    private final boolean isCritical;

    public PlayerInteractNPCEvent(Type type, int id, double damage, boolean isCritical) {
        super(true);
        this.type = type;
        this.id = id;
        this.damage = damage;
        this.isCritical = isCritical;
    }

    /**
     * @return InteractionType of the Event
     */
    public Type getType() {
        return type;
    }

    /**
     * @return EntityId of the Event
     */
    public int getId() {
        return id;
    }

    /**
     * @return Damage from Player to Entity (only use if Type=ATTACK)
     */
    public double getDamage() {
        return damage;
    }

    /**
     * @return Return if Player made a critical attack
     */
    public boolean getIsCritical() {
        return isCritical;
    }

    @Override
    public HandlerList getHandlers() {
        return handlers;
    }

    public static HandlerList getHandlerList() {
        return handlers;
    }

    public enum Type {
        ATTACK, INTERACT,
    }
}